package xidian.sl.service.impl.admin;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.List;

import jxl.Cell;
import jxl.CellType;
import jxl.DateCell;
import jxl.LabelCell;
import jxl.Sheet;
import jxl.Workbook;
import xidian.sl.dao.admin.ClassesDAO;
import xidian.sl.dao.admin.MajorDAO;
import xidian.sl.dao.admin.StuInforDAO;
import xidian.sl.entity.StuInfor;
import xidian.sl.service.admin.ExcelBatchInput;

public class ExcelBatchInputImpl implements ExcelBatchInput {
	private Sheet sheet;
	private String[][] excelValue;
	private int successRow;
	private int failRow;
	private StringBuilder msg=new StringBuilder();
	private String finalMsg;
	private StuInforDAO stuInforDAO;
	private MajorDAO majorDAO;
	private ClassesDAO classesDAO;
	/**
	 * excelܷ
	 */
	public String uploadStu(File upload) {
		System.out.println("ѧϢϴ");
		initExcel(upload);		//ʼ
		readExcel();			//ȡ
		insertIntoDB();	        //
		return msg.toString();
	}
	/**
	 * ȡexcelļݣ浽sheet
	 * @param upload
	 */
	private void initExcel(File upload) {
	    Workbook rwb = null;
	    try {
	    	InputStream is = new FileInputStream(upload);
	    	rwb = Workbook.getWorkbook(is);

	    	sheet = rwb.getSheet(0);
	    } 	catch (Exception e) {
	    	e.printStackTrace();
	    }
	}
	/**
	 * ȡexcelݽexcelValue
	 * е⣬ǱʵʵĶ
	 */
	private void readExcel(){
		excelValue = new String[sheet.getRows()][sheet.getColumns()];
	    for (int i = 0; i < sheet.getRows(); i++)
	    	for (int j = 0; j < sheet.getColumns(); j++) {
	    		Cell cell = sheet.getCell(j, i);
	    		if ("".equals(cell.getContents().toString().trim())){
	    			excelValue[i][j] = "";
	    		}
	    		if (cell.getType() == CellType.LABEL) {
	    			LabelCell labelcell = (LabelCell)cell;
	    			excelValue[i][j] = labelcell.getString().trim();
	    		} else if (cell.getType() == CellType.NUMBER){
	    			excelValue[i][j] = cell.getContents();
	    		} else if (cell.getType() == CellType.DATE) {
	    			DateCell datcell = (DateCell)cell;
	    			excelValue[i][j] = datcell.getDate().toString();
	    		} else {
	    			excelValue[i][j] = cell.getContents().toString().trim();
	    		}
	      }
	  }
	
	/**
	  * 3.ݿ
	  * @param course
	  */
	private void insertIntoDB() {
		int excelRows = excelValue.length;
		//Ϣ
		msg.delete(0, msg.length());
		finalMsg = "";
		successRow = 0;
		failRow = 0;
	    if (excelValue.length > 1) {
	    	for (int i = 1; i < excelRows; i++) {		//ӵڶſʼһΪ˵
	    		String[] DBValue = excelValue[i];		//ȡһ
	    		//ﱣ֤
	    		if(DBValue[0] != ""){
	    			if (validateInfor(i,DBValue)){
		    			successRow += 1;
		    			finalInsert(DBValue);
		    		} else {
		    			failRow += 1;
		    		}
	    		}
	    		
	    	}
	    		finalMsg = "¼ɹ"+"</br>"+"Ŀ굼ѧ"+(successRow+failRow)+"</br>"
				+"ɹ¼"+(successRow)+"</br>"
				+"ʧ¼"+(failRow)+"</br>"
				+msg.toString();
	    	System.out.println(finalMsg);
	    } else {
	    	finalMsg = "excelκݣ";
	    	System.out.println("excelûκ");
	    }
	}
	
	//շؼ
	private boolean validateInfor(int i,String[] DBValue){
		Boolean bol=true;
		if(!(validateNumRepeat(i,DBValue))){
			bol=false;
		}
		return bol;
	}
	
	//ѧǷظ
	private boolean validateNumRepeat(int i,String[] DBValue){
		boolean bolValidate=true;
		/**
		 * ҪѧǷظ
		 * ҪĽΪÿһͻһݿ
		 * */
		String hql = "from StuInfor";
		List<StuInfor> stuInfors = stuInforDAO.getStuInforListByHQL(hql);
		for(StuInfor stuInfor: stuInfors){
			if(stuInfor.getStuNum().equals(DBValue[1]) && DBValue[1]!=""){
				bolValidate=false;
				msg.append("Ϣ"+i+"ѧѧݿѴ洢ظ,ѧ["+DBValue[1]+"],ѧ["+DBValue[0]+"],飡</br>");
				return bolValidate;
			}
		}
		return bolValidate;
	}
	
	
	//ղ,Ҫ޸
	private void finalInsert(String[] DBValue){
			StuInfor stuInfor = new StuInfor();
			stuInfor.setStuName(DBValue[0]);
			stuInfor.setStuNum(DBValue[1]);
			stuInfor.setStuSex(DBValue[2]);
			stuInfor.setStuJg(DBValue[3]);
			stuInfor.setMajor(majorDAO.findById(Integer.valueOf(DBValue[4])));		//majorDAO.findById(Integer.valueOf(DBValue[4]))
			stuInfor.setStuStartTime(DBValue[5]);
			stuInfor.setStuEndTime(DBValue[6]);
			stuInfor.setStuWorkAddress(DBValue[7]);
			stuInfor.setStuWorkPlace(DBValue[8]);
			
			stuInfor.setStuWorkPost(DBValue[9]);
			stuInfor.setStuWorkZc(DBValue[10]);
			stuInfor.setStuPhone(DBValue[11]);
			stuInfor.setStuTelephone(DBValue[12]);
			stuInfor.setStuQq(DBValue[13]);
			
			stuInfor.setStuEmail(DBValue[14]);
			stuInfor.setStuCommAddress(DBValue[15]);
			stuInfor.setStuAddress(DBValue[16]);
			stuInfor.setStuSfzh(DBValue[17]);
			stuInfor.setStuNation(DBValue[18]);
			stuInfor.setStuBirth(DBValue[19]);
			stuInfor.setClasses(classesDAO.findById(Integer.valueOf(DBValue[20])));
			stuInfor.setStuPostcode(DBValue[21]);
			stuInfor.setLastXl(DBValue[22]);
			stuInfor.setLastXw(DBValue[23]);
			stuInfor.setSruHonour(DBValue[24]);
			stuInfor.setStuResume(DBValue[25]);
			stuInfor.setStuType(DBValue[26]);
			stuInfor.setDeleteType("1");
			/**
			 * ĬΪ֤ĺ6λڷ̨֤Ϊ10λ
			 * */
			String psw = "";
			if(DBValue[17].length() == 18){
				psw = DBValue[17].substring(12,18);
				stuInfor.setPassword(psw);
			}else if(DBValue[17].length() == 10){
				psw = DBValue[17].substring(4,10);
				stuInfor.setPassword(psw);
			}else{
				//ʡ֤洢ѧ
				stuInfor.setPassword(DBValue[1]);
			}
			
			stuInfor.setStuPhotoPath("0");
			stuInforDAO.makePersistence(stuInfor);
	}
	
	/*public static void main(String[] args) {
		String a = "330122199101021718";
		String psw = a.substring(12,18);
		System.out.println(psw);
	}*/
	
	public Sheet getSheet() {
		return sheet;
	}
	public void setSheet(Sheet sheet) {
		this.sheet = sheet;
	}
	public String[][] getExcelValue() {
		return excelValue;
	}
	public void setExcelValue(String[][] excelValue) {
		this.excelValue = excelValue;
	}
	public int getSuccessRow() {
		return successRow;
	}
	public void setSuccessRow(int successRow) {
		this.successRow = successRow;
	}
	public int getFailRow() {
		return failRow;
	}
	public void setFailRow(int failRow) {
		this.failRow = failRow;
	}
	public StringBuilder getMsg() {
		return msg;
	}
	public void setMsg(StringBuilder msg) {
		this.msg = msg;
	}
	public String getFinalMsg() {
		return finalMsg;
	}
	public void setFinalMsg(String finalMsg) {
		this.finalMsg = finalMsg;
	}

	public StuInforDAO getStuInforDAO() {
		return stuInforDAO;
	}
	public void setStuInforDAO(StuInforDAO stuInforDAO) {
		this.stuInforDAO = stuInforDAO;
	}
	public MajorDAO getMajorDAO() {
		return majorDAO;
	}
	public void setMajorDAO(MajorDAO majorDAO) {
		this.majorDAO = majorDAO;
	}
	public ClassesDAO getClassesDAO() {
		return classesDAO;
	}
	public void setClassesDAO(ClassesDAO classesDAO) {
		this.classesDAO = classesDAO;
	}
	
}
