package xidian.sl.service.impl.admin;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;

import xidian.sl.dao.admin.AdminDAO;
import xidian.sl.dao.admin.StuInforDAO;
import xidian.sl.entity.StuInfor;
import xidian.sl.service.admin.StuInforService;
import xidian.sl.util.PageUtil;

public class StuInforServiceImpl implements StuInforService {
	
	private static final Logger log = Logger.getLogger(StuInforServiceImpl.class);
	
	private StuInforDAO stuInforDAO;
	private AdminDAO adminDAO;
	
	public StuInforDAO getStuInforDAO() {
		return stuInforDAO;
	}

	public void setStuInforDAO(StuInforDAO stuInforDAO) {
		this.stuInforDAO = stuInforDAO;
	}
	
	public AdminDAO getAdminDAO() {
		return adminDAO;
	}

	public void setAdminDAO(AdminDAO adminDAO) {
		this.adminDAO = adminDAO;
	}

	@Override
	public String save(StuInfor stuInfor) {
		stuInforDAO.makePersistence(stuInfor);
		return stuInfor.getStuName();
	}

	@Override
	public List<StuInfor> getStuInforList(PageUtil pageUtil, String city, String showType, String major, String address, int searchType, String searchContext, Integer classesId, String sourceCity, Integer docProtitleId, Integer teaProtitleId) {
		return stuInforDAO.getStuInforList(pageUtil.getPageFirRecord(), pageUtil.getShowPageNum(),city, showType, major, address, searchType, searchContext, classesId, sourceCity, docProtitleId, teaProtitleId);
	}

	@Override
	public int getStuInforNums(String city, String showType, String major,
			String address, int searchType, String searchContext,
			Integer classesId, String sourceCity, Integer docProtitleId, Integer teaProtitleId) {
		return stuInforDAO.getSubNums(city, showType, major, address, searchType, searchContext, classesId, sourceCity, docProtitleId, teaProtitleId);
	}
	
	@Override
	public StuInfor getInforById(int id) {
		return stuInforDAO.getInforById(id);
	}

	@Override
	public void thoroughDelete(String idStr) {
		String[] ids = idStr.split("-");
		for(String id: ids){
			StuInfor stuInfor = stuInforDAO.findById(Integer.valueOf(id));
			log.info("ɹУѵɾɾУΪ  "+stuInfor.getStuName()+", ѧΪ  "+stuInfor.getStuNum());
			stuInforDAO.delete(Integer.valueOf(id));
		}
	}

	@Override
	public void update(StuInfor stuInfor) {
		stuInforDAO.update(stuInfor);
	}

	@Override
	public void updateDeleteSign(String idStr, String type) {
		String[] ids = idStr.split("-");
		for(String id: ids){
			StuInfor stuInfor = stuInforDAO.getInforById(Integer.valueOf(id));
			System.out.println("Ҫɾid  "+stuInfor.getStuId());
			if("ɾ".equals(type)){
				stuInfor.setDeleteType("0");
			}else{
				stuInfor.setDeleteType("1");
			}
			stuInforDAO.update(stuInfor);
		}
	}

	@Override
	public List<StuInfor> search(int searchType, String searchContext) {
		String hql = "from StuInfor as stu";
		if(searchType == 0){								//в
			System.out.println("ҵ =  "+searchContext);
			hql = hql + " where stu.stuName like '%"+searchContext+"%'";
		}else if(searchType == 1){							//ѧŽв
			hql = hql + " where stu.stuNum like '%"+searchContext+"%'";
		}else if(searchType == 2){							//רҵв
			hql = hql + " where stu.stuZy like '%"+searchContext+"%'";
		}else if(searchType == 3){							//ѧƽв
			hql = hql + " where stu.stuXz like '%"+searchContext+"%'";
		}else if(searchType == 4){							//ʡнв
			hql = hql + " where stu.stuWorkAddress like '%"+searchContext+"%'";
		}
		return stuInforDAO.getStuInforListByHQL(hql);
	}

	@Override
/*	public Map adminLogin(String admName, String admPsw)
			throws NameNotFoundException, PwNotMatchException {
		//System.out.println("û   = "+admName + admPsw);
		Admin admin = stuInforDAO.findAdminByName(admName);
		if(admin == null){
			throw new NameNotFoundException();
		}else if(!(admin.getAdminPw()).equals(admPsw)){
			throw new PwNotMatchException();
		}else{
			Map map=new HashMap();
			map.put("adminName", admin.getAdminNum());
			map.put("admin", admin);
			return map;
		}
	}

	@Override
	public void updateAdmin(Admin admin) {
		stuInforDAO.updateAdmin(admin);
	}*/
	
	/*
	 * excel
	 * */
	public InputStream getInputStream(String city, String major, String showType, String address, String idStr, String idStuStr, int searchType, String searchContext, Integer classesId, String sourceCity, Integer docProtitleId, Integer teaProtitleId) {
		System.out.println("idStr"+ idStuStr);
		String[] ids = idStr.split("-");
		HSSFWorkbook wb = new HSSFWorkbook();				//ʹpoipoiİҪһHSSFWorkbook
		HSSFSheet sheet = wb.createSheet("sheet1");			//excelsheet
		
		HSSFRow row=sheet.createRow(0);						//һ
		HSSFCell cell=row.createCell((short)0);				//һԪ
		cell.setEncoding(HSSFCell.ENCODING_UTF_16);			//ÿԪҪñʽ
		cell.setCellValue("");
		for(int i=0;i<ids.length; i++){
			cell=row.createCell((short)(i+1));				//δԪ
			cell.setEncoding(HSSFCell.ENCODING_UTF_16);		//ÿԪҪñʽ
			cell.setCellValue(ids[i]);
		}
		/*
		 * ˱ͷѾƺ,ͽݵĲ
		 * */
		List<StuInfor> stuInfors = new ArrayList<StuInfor>();
		if(idStuStr == null|| "0".equals(idStuStr)){
			//ͼexcel
			stuInfors = stuInforDAO.getStuInforListByHQL(stuInforDAO.getHQL(city, showType, major, address, searchType, searchContext, classesId, sourceCity, docProtitleId, teaProtitleId));
			System.out.println("С"+ stuInfors.size());
		}else{	
			//ѡѧе
			stuInfors = stuInforDAO.getStuInforListByHQL(getHql(idStuStr));
		}
		for(int i=0;i<stuInfors.size();i++){
			StuInfor stuInfor = stuInfors.get(i);				//һ¼
			row=sheet.createRow(i+1);							//
			cell=row.createCell((short)0);						//һԪ
			cell.setEncoding(HSSFCell.ENCODING_UTF_16);
			cell.setCellValue(i+1);
			
			for(int a=0;a<ids.length; a++){   					//ĵԪʾҪʾ
				cell=row.createCell((short)(a+1));
				cell.setEncoding(HSSFCell.ENCODING_UTF_16);
				//жϿѭ
				if(ids[a].equals("ѧѧ")){
					cell.setCellValue(stuInfor.getStuNum());
				}else if(ids[a].equals("ѧ")){
					cell.setCellValue(stuInfor.getStuName());
				}else if(ids[a].equals("ѧԱ")){
					cell.setCellValue(stuInfor.getStuSex());
				}else if(ids[a].equals("ѧרҵ")){
					cell.setCellValue(stuInfor.getMajor().getMajorName());
				}else if(ids[a].equals("༶")){
					cell.setCellValue(stuInfor.getClasses().getClassesName());
				}else if(ids[a].equals("ѧ")){
					cell.setCellValue(stuInfor.getStuStartTime());
				}else if(ids[a].equals("ҵ")){
					cell.setCellValue(stuInfor.getStuEndTime());
				}else if(ids[a].equals("")){
					cell.setCellValue(stuInfor.getStuEmail());
				}else if(ids[a].equals("ͨŵַ")){
					cell.setCellValue(stuInfor.getStuCommAddress());
				}else if(ids[a].equals("ַͥ")){
					cell.setCellValue(stuInfor.getStuAddress());
				}else if(ids[a].equals("ҵʡ")){
					cell.setCellValue(stuInfor.getStuWorkAddress());
				}else if(ids[a].equals("λ")){
					cell.setCellValue(stuInfor.getStuWorkPlace());
				}else if(ids[a].equals("λ")){
					cell.setCellValue(stuInfor.getStuWorkPost());
				}else if(ids[a].equals("ְְ")){
					cell.setCellValue(stuInfor.getStuWorkZc());
				}else if(ids[a].equals("칫绰")){
					cell.setCellValue(stuInfor.getStuPhone());
				}else if(ids[a].equals("QQ")){
					cell.setCellValue(stuInfor.getStuQq());
				}else if(ids[a].equals("ֻ")){
					cell.setCellValue(stuInfor.getStuTelephone());
				}else if(ids[a].equals("֤")){
					cell.setCellValue(stuInfor.getStuSfzh());
				}else if(ids[a].equals("ڹ")){
					cell.setCellValue(stuInfor.getStuNation());
				}else if(ids[a].equals("Դʡ")){
					cell.setCellValue(stuInfor.getStuBirth());
				}else if(ids[a].equals("У")){
					cell.setCellValue(stuInfor.getStuType());
				}else if(ids[a].equals("ͨʱ")){
					cell.setCellValue(stuInfor.getStuPostcode());
				}else if(ids[a].equals("ѧѧУ")){
					cell.setCellValue(stuInfor.getLastXl());
				}else if(ids[a].equals("ѧλѧУ")){
					cell.setCellValue(stuInfor.getLastXw());
				}else if(ids[a].equals("")){
					cell.setCellValue(stuInfor.getSruHonour());
				}else if(ids[a].equals("˼")){
					cell.setCellValue(stuInfor.getStuResume());
				}else if(ids[a].equals("ҽʦְ")){
					cell.setCellValue(stuInfor.getDocProtitle().getDocProtitleName());
				}else if(ids[a].equals("ʦְ")){
					cell.setCellValue(stuInfor.getTeaProtitle().getTeaProtitleName());
				}
			}
		}
		/*
		 * Ͼexcelļ
		 *дһֱӲʱļڴ
		*/
		ByteArrayOutputStream os=new ByteArrayOutputStream();
		try {
			wb.write(os);
		} catch (IOException e) {
			e.printStackTrace();
		}
		byte[] content=os.toByteArray();
		InputStream is=new ByteArrayInputStream(content);
		return is;
		
	}
	
	private String getHql(String idStuStr){
		String[] stus = idStuStr.split("-");
		StringBuilder sb = new StringBuilder();
		for(int i = 0; i< stus.length; i++){
			sb.append(stus[i]);
			if(i!= (stus.length-1)){
				sb.append(",");
			}
			//System.out.println(sb.toString());
		}
		String hql = "from StuInfor as stu where stu.id in ("+sb.toString()+")";
		return hql;
	}
	@Override
	public int getEyeNums(String city, String showType, String address, int searchType, String searchContext, Integer classesId, String sourceCity, String major, String majorName, Integer docProtitleId, Integer teaProtitleId) {
		String hql = stuInforDAO.getHQL(city, showType, major, address, searchType, searchContext, classesId, sourceCity, docProtitleId, teaProtitleId);
		if(hql.contains("where")){	
			hql = hql + " and stu.major.majorName = '"+majorName+"'";
		}else{
			hql = hql + " where stu.major.majorName = '"+majorName+"'";
		}
		return stuInforDAO.getStuInforListByHQL(hql).size();
	}

	@Override
	public List<StuInfor> getStuInforList(String city, String major, String showType, String address, int searchType, String searchContext, Integer classesId, String sourceCity, Integer docProtitleId, Integer teaProtitleId) {
		String hql = stuInforDAO.getHQL(city, showType, major, address, searchType, searchContext, classesId, sourceCity, docProtitleId, teaProtitleId);
		System.out.println("hqlΪ" + hql);
		return stuInforDAO.getStuInforListByHQL(hql);
	}

	@Override
	public StuInfor getStuInforByNum(String stuNum) {
		return stuInforDAO.getStuInforByNum(stuNum);
	}
	@Override
	public List<StuInfor> getClassesStu(int classesId) {
		String hql = "from StuInfor as stu where stu.classes.classesId = "+classesId+"";
		return stuInforDAO.findListByHQL(hql);
	}

	@Override
	public int getWorkNumsByCity(Integer type, String city) {
		String hql = null;
		if(type == 0){				//ʾҵֲ
			hql = "from StuInfor as stu where stu.stuWorkAddress like '%"+city+"%'";
		}else if(type == 1){		//ʾԴֲ
			hql = "from StuInfor as stu where stu.stuBirth like '%"+city+"%'";
		}
		
		return stuInforDAO.findListByHQL(hql).size();
	}

	@Override
	public void authorization(String idStr, String authorization) {
		String[] ids = idStr.split("-");
		for(String id: ids){
			StuInfor stuInfor = getInforById(Integer.valueOf(id));
			log.info("ȨУѣȨУΪ  "+stuInfor.getStuName()+", ѧΪ  "+stuInfor.getStuNum()+", ȨΪ  "+authorization);
			stuInfor.setStuType(authorization);
			update(stuInfor);
		}
	}

	@Override
	public List<StuInfor> getStuInforList() {
		String hql = "from StuInfor as stu where (stu.stuSfzh !='' and stu.stuSfzh is not null) and (stu.stuPhotoPath = '0' or stu.stuPhotoPath is null)";
		return stuInforDAO.getStuInforListByHQL(hql);
	}

	@Override
	public StuInfor getInforBySfz(String sfz) {
		String hql = "from StuInfor as stu where stu.stuSfzh = '"+sfz+"'";
		return stuInforDAO.getStuInforListByHQL(hql).get(0);
	}

	@Override
	public String getStuName(String type, Integer id) {
		String data = null;
		if("ͨԱ".equals(type)|| "Ա".equals(type)){
			data = adminDAO.findById(id).getAdminNum();
		}else if("Ա".equals(type)|| "".equals(type)|| "ͨУ".equals(type)){
			data = stuInforDAO.findById(id).getStuNum();
		}
		return data;
	}

}
