package xidian.sl.util.mail;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

import javax.mail.Address;
import javax.mail.BodyPart;
import javax.mail.Folder;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Multipart;
import javax.mail.Part;
import javax.mail.Session;
import javax.mail.Store;
import javax.mail.Flags.Flag;
import javax.mail.internet.MimeMultipart;
import javax.mail.internet.MimeUtility;

/**
 * ȡʼ
 */
public class MailReader {
	
	@SuppressWarnings("deprecation")
	public static List<MailReaderInfo> readMail(String imapServerHost, String username, String password){
		List<MailReaderInfo> mailReaderInfos = new ArrayList<MailReaderInfo>();
		Store store = null;
		Folder folder = null;
		try {
				//ȡĬϻỰ
			   Properties props = System.getProperties();
//			   props.setProperty("mail.imap.auth.login.disable", "true"); 
			   Session session = Session.getDefaultInstance(props, null);
			   //򿪵ģʽ
//			   session.setDebug(true);
			   //ʹPOP3Ựƣӷ
			   store = session.getStore("pop3");
			   store.connect(imapServerHost, username, password);
			   //ȡĬļ
			   folder = store.getDefaultFolder();
			   if (folder == null) {
				   throw new Exception("No default folder");
			   }
			   //ռ
			   folder =  folder.getFolder("INBOX");
			   if (folder == null) {
				   		throw new Exception("No POP3 INBOX");
			   }
			   //ʹöдʽռ
			   folder.open(Folder.READ_WRITE);
			   //õļϢȡʼб
			   Message[] msgs = folder.getMessages();
			   
			   //ʼMailReadInfo
			   for (int i = 0; i < msgs.length; i++) {
				   Message message = msgs[i];
				   MailReaderInfo mailReaderInfo = new MailReaderInfo();
				   
				   //÷ˣ";"Ÿ
				   String fromAddress="";
				   if (message.getFrom()!=null) {
					   for (Address from : message.getFrom()) {
						   fromAddress+=MimeUtility.decodeText(from.toString())+";";
					   }
				   }else {
					fromAddress="ûз";
				   }
				   
				   mailReaderInfo.setFormAddress(fromAddress);
				   
//				   System.out.println("="+fromAddress);
				   
				   //ռˣռ";"Ÿ
				   String toAddress="";
				   if (message.getAllRecipients()!=null) {
					  
					   for (Address to : message.getAllRecipients()) {
						   if (to!=null) {
							   toAddress+=MimeUtility.decodeText(to.toString())+";";
						   }
					   }
				   }else {
					   toAddress ="ָռˣ";
				   }
//				   System.out.println("ռ="+toAddress);
				   
				   
				   mailReaderInfo.setToAddress(toAddress);
				   //ռʱ
				   if (message.getSentDate()!=null) {
					   mailReaderInfo.setDate(MimeUtility.decodeText(message.getSentDate().toLocaleString()));
				   }else {
					   mailReaderInfo.setDate("ûռʱ");
				   }
//				   System.out.println("ռʱ="+mailReaderInfo.getDate());
				   
				   //ʼݴ
				   String content="";
				   List<String> attachments = new ArrayList<String>();
				   //ʼǶಿֵģܰҲʹpart.isMimeType("multipart/*")ж 
				   if (message.getContent().getClass().equals(MimeMultipart.class) ) {
					   Multipart multipart = (Multipart) message.getContent();
					   for (int j = 0; j < multipart.getCount(); j++) {
						   BodyPart bodyPart = multipart.getBodyPart(j);
//						   System.out.println((j+1)+"="+bodyPart.getDisposition());
						   String dispostion = bodyPart.getDisposition();
						   //жǷиеĻ棬浽D̵attachmentļ
						   if((dispostion!=null)&&(dispostion.toLowerCase().equals(Part.ATTACHMENT)||dispostion.toLowerCase().equals(Part.INLINE))){
			                    String filename = MimeUtility.decodeText(bodyPart.getFileName());
			                    if (filename.lastIndexOf("_")!=-1) {
			                    	filename = filename.substring(filename.lastIndexOf("_")+1);
								}else if (filename.lastIndexOf("\\")!=-1) {
									filename = filename.substring(filename.lastIndexOf("\\")+1);
								}
			                    //渽
			                    String path = saveFile(filename,bodyPart.getInputStream());
			                    if (!path.equals("error")) {
			                    	System.out.println("ɹ");
			                    	attachments.add(path);
								}else {
									System.out.println("ʧ");
								}
			                }
						   else {
							   content = bodyPart.getContent().toString();
						}
					   }
				}else {
					content =  message.getContent().toString();
				}
				   System.out.println("="+content);
				   
				   //
				   mailReaderInfo.setContent(content);
				   //ʼ
				   mailReaderInfo.setSubject(message.getSubject());
				   //渽
				   if (attachments!=null) {
					   mailReaderInfo.setAttachments(attachments);
				   }	
				   mailReaderInfos.add(mailReaderInfo);
			   }
			   
		} catch (Exception e) {
			e.printStackTrace();
		}finally{
			   //ͷԴ
			   try{
			    if (folder!=null){
			    	//ɾļfolder.delete(true);
			    	folder.delete(true);
			    	folder.close(false);
			    }
			    if (store!=null){
			    	store.close();
			    }
			   }catch (Exception ex2) {
			    ex2.printStackTrace();
			   }
			  }
		
		return mailReaderInfos;
	}
	
	
	 private static String saveFile(String filename, InputStream inputStream) throws IOException {
		 try {
			 	BufferedOutputStream bos = null;
			 	BufferedInputStream bis = null;
			 	File storefile = new File("D:\\attachment\\"+filename);
			 	File dir = storefile.getParentFile();
			 	if (!dir.exists()) {
					dir.mkdirs();
				}
	        	bos = new BufferedOutputStream(new FileOutputStream(storefile));
	            bis = new BufferedInputStream(inputStream);
	            int c;
	            while((c= bis.read())!=-1){
	                bos.write(c);
	                bos.flush();
	            }
	            return storefile.getName();
			} catch (Exception e) {
				e.printStackTrace();
				return "error";
			}
	    }
	 
	 /**
	  * жʼǷѶ
	  * @param message ȡʼ
	  * @return ǷѶ
	  * @throws MessagingException
	  */
	 public static boolean isRead(Message message)throws MessagingException {
		  Flag[] flags = message.getFlags().getSystemFlags();
		  for (Flag f : flags) {
		   if (f.equals(Flag.SEEN))
		    return true;
		  }
		  return false;
	 }
	
	
	public static void main(String[] args) {
//		List<MailReaderInfo> readers =  readMail();
//		System.out.println("="+readers.get(0).getContent());
		String string = "13@Сaa@123@@@Сaa@163.com@@@@@ ";
		String[] strings = string.split("@");
		for (int i = 0; i < strings.length; i++) {
			System.err.println((i+1)+"="+strings[i]);
		}
	}

}
